




#ifndef Wagnis_Player_h
#define Wagnis_Player_h

#include "Wagnis.h"
#include "OrxonoxPrereqs.h"
#include "core/CoreIncludes.h"
#include "core/XMLPort.h"
#include "WagnisProvince.h"
#include "WagnisGameboard.h"
#include <vector>
#include <string>
#include "infos/HumanPlayer.h"

enum MoveType { ATTACK, MOVE, SET_TROOPS, SET_TROOPS_INITIAL };
enum GameStagexyz { CHOOSE_PROVINCE_STAGE, REINFORCEMENT_STAGE, ATTACK_STAGE, MOVE_STAGE };



namespace orxonox
{
    class WagnisPlayer : public HumanPlayer, public Tickable
    {
    public:
        WagnisPlayer(Context*);
        virtual ~WagnisPlayer();
        void tick(float);

        void playerTurn();
        bool checkMove(WagnisProvince*,WagnisProvince*,MoveType);
        void setTroops(WagnisProvince*);
        void attack(WagnisProvince*,WagnisProvince*);
        void moveTroops(WagnisProvince*,WagnisProvince*);
        std::string toString();



        GameStagexyz gamestage;
        bool province_selection_changed;
        bool is_active;
        int Player_ID;
        WagnisGameboard* gameBoard;
        WagnisProvince* origin_province;
        WagnisProvince* target_province;
        bool isNeighbour(WagnisProvince*,WagnisProvince*);
        bool existPath(WagnisProvince*,WagnisProvince*);
    };
}


#endif
